
#include "ctrlplug.h"

#include <fstream>
template< typename...A> void LOGIT(A...a) { std::ofstream ofs("/home/mais/plug_in_libs/LOGFILE.txt", std::ios::app); (ofs << ... << a); ofs << "\n"; }


CtrlPlug::~CtrlPlug() { }
CtrlPlug::CtrlPlug()
{
	LOGIT("ctor");
	cpdata.sname="CtrlPlug";
	cpdata.nval=0;
	cpdata.ink=Blue();
	cpdata.bg=LtCyan();
	cpdata.bbox=false;
}

void CtrlPlug::Paint(Draw &drw)
{
	GuiLock __;
	LOGIT("paint");
	Size sz=GetSize();
	drw.DrawRect(sz, cpdata.bg);
	Size tsz=GetTextSize(cpdata.sname, StdFont());
	drw.DrawText(((sz.cx-tsz.cx)/2), ((sz.cy-tsz.cy)/2), cpdata.sname, StdFont(), cpdata.ink);
}

String CtrlPlug::getname()
{
	LOGIT("getname");
	return cpdata.sname;
}

void CtrlPlug::setname(String S)
{
	LOGIT("setname");
	cpdata.sname=S;
}


int CtrlPlug::getval()
{
	LOGIT("getval");
	return cpdata.nval;
}

void CtrlPlug::makechange()
{
	LOGIT("makechange");
	char c;
	std::string s=cpdata.sname.ToStd();
	int i=0, n=(s.size()/2);
	while (i<n)
	{
		c=s[i];
		s[i]=s[s.size()-i-1];
		s[s.size()-i-1]=c;
		i++;
	}
	cpdata.sname=s.c_str();
	Refresh();
}

void CtrlPlug::doeval(int v)
{
	LOGIT("doeval");
	cpdata.nval+=v;
	Refresh();
}

//void CtrlPlug::dosetup(Ctrl *pPar, Rect R) { pPar->AddChild(this); SetRect(R); Sync(); Refresh(); }

extern "C" CtrlBase* CreatePlug() { return new CtrlPlug; }
extern "C" void DestroyPlug(CtrlBase *p) { if (p) delete (CtrlPlug*)p; }


